Bio::SearchIO::exonerate(3)

NAME
Bio::SearchIO::exonerate - parser for Exonerate

SYNOPSIS
  # do not use this module directly, it is a driver for SearchIO

  use Bio::SearchIO;
  my $searchio = new Bio::SearchIO(-file => 'file.exonerate',
                                   -format => 'exonerate');

  while( my $r = $searchio->next_result ) {
    print $r->query_name, "\n";
  }

DESCRIPTION
This is a driver for the SearchIO system for parsing Exonerate (Guy Slater) output. You can get Exonerate at http://cvsweb.sanger.ac.uk/cgi-bin/cvsweb.cgi/exonerate/?cvsroot=Ensembl [until Guy puts up a Web reference,publication for it.]).

An optional parameter -min_intron is supported by the new initialization method. This is if you run Exonerate with a different minimum intron length (default is 30) the parser will be able to detect the difference between standard deletions and an intron. Still some room to play with there that might cause this to get misinterpreted that has not been fully tested or explored.

The VULGAR and CIGAR formats should be parsed okay now creating HSPs where appropriate (so merging match states where appropriate rather than breaking an HSP at each indel as it may have done in the past). The GFF that comes from exonerate is still probably a better way to go if you are doing protein2genome or est2genome mapping. For example you can see this script:

http://fungal.genome.duke.edu/~jes12/software/scripts/process_exonerate_gff3.pl

If your report contains both CIGAR and VULGAR lines only the first one will processed for a given Query/Target pair. If you preferentially want to use VULGAR or CIGAR add one of these options when initializing the SearchIO object.

    -cigar => 1
    -vulgar => 1

Or set them via these methods.

    $parser->cigar(1)
    $parser->vulgar(1)

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to the Bioperl mailing list. Your participation is much appreciated.

  bioperl-l@bioperl.org              - General discussion
  http://bioperl.org/MailList.shtml  - About the mailing lists

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track of the bugs and their resolution. Bug reports can be submitted via the web:

  http://bugzilla.bioperl.org/

AUTHOR - Jason Stajich
Email jason-at-bioperl.org

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  new
 Title   : new
 Usage   : my $obj = new Bio::SearchIO::exonerate();
 Function: Builds a new Bio::SearchIO::exonerate object
 Returns : an instance of Bio::SearchIO::exonerate
 Args    : -min_intron => somewhat obselete option, how to determine if a
                          an indel is an intron or a local gap.  Use VULGAR
                          rather than CIGAR to avoid this heuristic,default 30.
           -cigar       => 1   set this to 1 if you want to parse
                               CIGAR exclusively.
           -vulgar      => 1   set this to 1 if you want to parse VULGAR
                               exclusively, setting both to 1 will revert
                               to the default behavior of just parsing the
                               first line that it sees.

  next_result
 Title   : next_result
 Usage   : my $hit = $searchio->next_result;
 Function: Returns the next Result from a search
 Returns : Bio::Search::Result::ResultI object
 Args    : none

  start_element
 Title   : start_element
 Usage   : $eventgenerator->start_element
 Function: Handles a start element event
 Returns : none
 Args    : hashref with at least 2 keys 'Data' and 'Name'

  end_element
 Title   : start_element
 Usage   : $eventgenerator->end_element
 Function: Handles an end element event
 Returns : none
 Args    : hashref with at least 2 keys 'Data' and 'Name'

  element
 Title   : element
 Usage   : $eventhandler->element({'Name' => $name, 'Data' => $str});
 Function: Convience method that calls start_element, characters, end_element
 Returns : none
 Args    : Hash ref with the keys 'Name' and 'Data'

  characters
 Title   : characters
 Usage   : $eventgenerator->characters($str)
 Function: Send a character events
 Returns : none
 Args    : string

  within_element
 Title   : within_element
 Usage   : if( $eventgenerator->within_element($element) ) {}
 Function: Test if we are within a particular element
           This is different than 'in' because within can be tested
           for a whole block.
 Returns : boolean
 Args    : string element name

  in_element
 Title   : in_element
 Usage   : if( $eventgenerator->in_element($element) ) {}
 Function: Test if we are in a particular element
           This is different than 'in' because within can be tested
           for a whole block.
 Returns : boolean
 Args    : string element name

  start_document
 Title   : start_document
 Usage   : $eventgenerator->start_document
 Function: Handle a start document event
 Returns : none
 Args    : none

  end_document
 Title   : end_document
 Usage   : $eventgenerator->end_document
 Function: Handles an end document event
 Returns : Bio::Search::Result::ResultI object
 Args    : none

  vulgar
 Title   : vulgar
 Usage   : $obj->vulgar($newval)
 Function: Get/Set flag, do you want to build HSPs from VULGAR string?
 Returns : value of vulgar (a scalar)
 Args    : on set, new value (a scalar or undef, optional)

  cigar
 Title   : cigar
 Usage   : $obj->cigar($newval)
 Function: Get/Set boolean flag do you want to build HSPs from CIGAR strings?
 Returns : value of cigar (a scalar)
 Args    : on set, new value (a scalar or undef, optional)